"""
A program that executes an algorithm to measure out 4 litres from containers of 7l and 5l.
The 4l must be contained in the smaller container at the end of the process, and the larger one empty.
You can : fill either container from a tap; empty one container into another until one is full or the other empty; empty a container into a sink.
The algorithm is:
1. Fill the larger container.
2. Pour the large one into the small one, until the smaller container is full or the larger one is empty
3. Empty the small one into a sink
4. Pour the difference from the larger into the smaller

Repeat steps 1-4.

The larger container will be empty and the smaller one will contain 4l.

"""

def Create_Container(number, volume) :
    currentV = 0
    newc = {"number":number, "maxVolume":volume, "currentVolume":currentV }
    return newc

def Fill_Container(thisC) :
    thisC["currentVolume"] = thisC["maxVolume"]

def Empty_Container(thisC) :
    thisC["currentVolume"] = 0


def Pour_LargetoSmall(lC, sC) :
    sC["currentVolume"] = sC["currentVolume"] +lC["currentVolume"]  #pour the large entirely into small: if the small volume is below max then no more to do on small C
    lC["currentVolume"] = 0                                         #empty the large C
    if sC["currentVolume"] > sC["maxVolume"] :                      #if small current volume exceeds the max volume of the small, put difference back in
        overCapacity = sC["currentVolume"] - sC["maxVolume"]
        lC["currentVolume"] = overCapacity                          #pour the surplus back into the large C
        sC["currentVolume"] = sC["maxVolume"]                       #make sure the small C doesnt contain more than the max


	
# main program ... execute the 4 steps of the algorithm; twice
#Initialise the large and small container
largeC = Create_Container(1, 7)
print("Large Container : ", largeC["maxVolume"], "litres")
smallC = Create_Container(2, 5)
print("Small Container : ", smallC["maxVolume"], "litres")
print("\n")

for i in range(2):
    #Execute the 4 steps of the algorithm
    Fill_Container(largeC)                  # Step 1
    print("1. Fill the large" + "\t"*2 + "LARGE:" , largeC["currentVolume"], " small: ", smallC["currentVolume"])
    
    Pour_LargetoSmall(largeC, smallC)       # Step 2
    print("2. Pour large into small\tLARGE:" , largeC["currentVolume"], " small: ", smallC["currentVolume"])
    
    Empty_Container(smallC)                 # Step 3
    print("3. Empty small into sink\tLARGE:" , largeC["currentVolume"], " small: ", smallC["currentVolume"])
    
    Pour_LargetoSmall(largeC, smallC)       # Step 4
    print("4. Pour large into small\tLARGE:" , largeC["currentVolume"], " small: ", smallC["currentVolume"], "\n")


    
print("\nSlán go fóill. The volume in the small container is", smallC["currentVolume"],"litres.")


       

